local AddonName, AddonTable = ...
local L = AddonTable.Localize
local s = SpellFlashAddon
local a = AddonTable

local parent = AddonName.."_SpellFlashAddonOptionsFrame"
a.OptionsFrame = CreateFrame("Frame", parent, nil, "SpellFlashAddon_OptionsFrameTemplate2")

local CustomButtonOptions = {
	LeftCheckButton1 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	LeftCheckButton2 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	LeftCheckButton3 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	LeftCheckButton4 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	LeftCheckButton5 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	LeftCheckButton6 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	LeftCheckButton7 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton1 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton2 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton3 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton4 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton5 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton6 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
	RightCheckButton7 = {
		DefaultChecked = true,
		ConfigKey = "My_Config_Key",
		Label = L["My_Check_Button_Label"],
	},
}

function a.OptionsFrame.okay()
	s.SetModuleConfig(AddonName, "spell_flashing_off", not _G[parent.."_SpellFlashing"]:GetChecked())
	for button, options in pairs(CustomButtonOptions) do
		if options.ConfigKey and options.ConfigKey ~= "My_Config_Key" then
			if options.DefaultChecked then
				s.SetModuleConfig(AddonName, options.ConfigKey, not _G[parent..button]:GetChecked())
			else
				s.SetModuleConfig(AddonName, options.ConfigKey, not not _G[parent..button]:GetChecked())
			end
		end
	end
	if type(a.Spam) == "table" and type(a.Spam[1]) == "table" and type(a.Spam[1].Function) == "function" then
		local Value = _G[parent.."_ScriptSlider"]:GetValue()
		if Value == 1 or type(a.Spam[Value]) ~= "table" or type(a.Spam[Value].Function) ~= "function" then
			Value = nil
		end
		s.SetModuleConfig(AddonName, "script_number", Value)
	end
end

function a.OptionsFrame.refresh()
	_G[parent.."_SpellFlashing"]:SetChecked(not s.GetModuleConfig(AddonName, "spell_flashing_off"))
	for button, options in pairs(CustomButtonOptions) do
		if options.ConfigKey and options.ConfigKey ~= "My_Config_Key" then
			if options.DefaultChecked then
				_G[parent..button]:SetChecked(not s.GetModuleConfig(AddonName, options.ConfigKey))
			else
				_G[parent..button]:SetChecked(s.GetModuleConfig(AddonName, options.ConfigKey))
			end
			_G[parent..button.."Text"]:SetText(options.Label)
			_G[parent..button]:Show()
		end
	end
	if type(a.Spam) == "table" and type(a.Spam[1]) == "table" and type(a.Spam[1].Function) == "function" then
		_G[parent.."_ScriptSlider"]:Show()
		_G[parent.."_ScriptSliderTitle"]:Show()
		_G[parent.."_ScriptSliderDescription"]:Show()
		_G[parent.."_ScriptSliderMinValue"]:Show()
		_G[parent.."_ScriptSliderMaxValue"]:Show()
		_G[parent.."_ScriptSliderValue"]:Show()
		local MaxValue = getn(a.Spam)
		_G[parent.."_ScriptSlider"]:SetMinMaxValues(1, MaxValue)
		_G[parent.."_ScriptSliderMinValueLabel"]:SetText("1")
		_G[parent.."_ScriptSliderMaxValueLabel"]:SetText(""..MaxValue)
		local Value = s.GetModuleConfig(AddonName, "script_number") or 1
		if type(a.Spam[Value]) ~= "table" or type(a.Spam[Value].Function) ~= "function" then
			Value = 1
		end
		_G[parent.."_ScriptSlider"]:SetValue(Value)
		_G[parent.."_ScriptSliderTitleLabel"]:SetText(a.Spam[Value].Title or "")
		_G[parent.."_ScriptSliderDescriptionLabel"]:SetText(a.Spam[Value].Description or "")
		_G[parent.."_ScriptSliderValueLabel"]:SetText(""..Value)
	end
end

function a.OptionsFrame.default()
	s.ClearAllModuleConfigs(AddonName)
end

L["Spell Flashing"] = s.L["Spell Flashing"]
local function LocalizeFontStrings(frame)
	for _, f in next, {frame:GetChildren()} do
		if f:GetObjectType() == "FontString" then
			f:SetText(L[f:GetText()])
		else
			for _, f in next, {f:GetRegions()} do
				if f:GetObjectType() == "FontString" then
					f:SetText(L[f:GetText()])
				end
			end
		end
	end
end
LocalizeFontStrings(a.OptionsFrame)
_G[parent.."TitleString"]:SetText(select(2, GetAddOnInfo(AddonName)).." "..GetAddOnMetadata(AddonName, "Version"))

function a.OptionsFrame.UpdateSliderText(self)
	if self and self:IsVisible() then
		local Value = self:GetValue()
		if type(a.Spam[Value]) ~= "table" or type(a.Spam[Value].Function) ~= "function" then
			Value = 1
		end
		_G[parent.."_ScriptSliderTitleLabel"]:SetText(a.Spam[Value].Title or "")
		_G[parent.."_ScriptSliderDescriptionLabel"]:SetText(a.Spam[Value].Description or "")
		_G[parent.."_ScriptSliderValueLabel"]:SetText(""..Value)
	end
end

function a.RunSpamTable()
	if type(a.Spam) == "table" then
		local i = s.GetModuleConfig(AddonName, "script_number") or 1
		if type(a.Spam[i]) == "table" and type(a.Spam[i].Function) == "function" then
			a.Spam[i].Function()
		elseif type(a.Spam[1]) == "table" and type(a.Spam[1].Function) == "function" then
			s.SetModuleConfig(AddonName, "script_number", nil)
			a.Spam[1].Function()
		end
	end
end

a.OptionsFrame.parent = select(2, GetAddOnInfo("SpellFlash"))
a.OptionsFrame.name = select(2, GetAddOnInfo(AddonName))
InterfaceOptions_AddCategory(a.OptionsFrame)
